Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.java.ao.db
Class SQLServerDatabaseProvider

    java.lang.Object
      net.java.ao.DatabaseProvider
          net.java.ao.db.SQLServerDatabaseProvider

    public class SQLServerDatabaseProvider

extends DatabaseProvider

Author:
  Daniel Spiewak

Field Summary

Fields inherited from class net.java.ao.DatabaseProvider
`eventManager`

Constructor Summary
`SQLServerDatabaseProvider(DisposableDataSource dataSource)`

Method Summary
`protected boolean` | `considerPrecision(DDLField field)` Determines whether or not the database allows explicit precisions for the field in question.
`protected String` | `convertTypeToString(DatabaseType<?> type)` Converts the specified type into the database-specific DDL String value.
`protected Set<String>` | `getReservedWords()` Retrieves the set of all reserved words for the underlying database.
`ResultSet` | `getTables(Connection conn)` Returns a result set of all of the tables (and associated meta) in the database.
`
`<T> T`
` | `insertReturningKey(EntityManager manager, Connection conn, Class<T> pkType, String pkField, boolean pkIdentity, String table, DBParam... params)` Generates an INSERT statement to be used to create a new row in the database, returning the primary key value.
`Object` | `parseValue(int type, String value)` Parses the database-agnostic `String` value relevant to the specified SQL type in `int` form (as defined by `Types` and returns the Java value which corresponds.
`protected String[]` | `renderAlterTableAddColumn(DDLTable table, DDLField field)` Generates the database-specific DDL statements required to add a column to an existing table.
`protected String` | `renderAlterTableChangeColumnStatement(DDLTable table, DDLField oldField, DDLField field)` Generates the database-specific DDL statement only for altering a table and changing a column.
`protected String` | `renderAlterTableDropKey(DDLForeignKey key)` Generates the database-specific DDL statement required to remove a foreign key from a table.
`protected String` | `renderAutoIncrement()` Generates the DDL fragment required to specify an INTEGER field as auto-incremented.
`protected String` | `renderFunction(DatabaseFunction func)` Renders the specified `DatabaseFunction` in its database-specific form.
`protected String` | `renderOnUpdate(DDLField field)` Renders the appropriate field suffix to allow for the `OnUpdate` functionality.
`protected String` | `renderQueryLimit(Query query)` Renders the LIMIT portion of the query in the database-specific SQL dialect.
`protected String` | `renderQuerySelect(Query query, TableNameConverter converter, boolean count)` Renders the SELECT portion of a given `Query` instance in the manner required by the database-specific SQL implementation.
`protected String` | `renderTriggerForField(DDLTable table, DDLField field)` Renders the trigger which corresponds to the specified field, or `null` if none.
`void` | `setQueryResultSetProperties(ResultSet res, Query query)` Allows the provider to set database-specific options on a `ResultSet` instance prior to its use by the library.

Methods inherited from class net.java.ao.DatabaseProvider
`dispose, executeInsertReturningKey, getConnection, getDateFormat, getEventManager, getFunctionNameForField, getMaxIDLength, getSequences, getTriggerNameForField, handleBlob, handleUpdateError, isCaseSensetive, isNumericType, processID, processWhereClause, putBoolean, putNull, renderAction, renderAlterTableAddKey, renderAlterTableChangeColumn, renderAlterTableDropColumn, renderAppend, renderCalendar, renderConstraintsForTable, renderCreateIndex, renderDropFunctions, renderDropIndex, renderDropSequences, renderDropTable, renderDropTriggers, renderField, renderFieldPrecision, renderFieldType, renderForeignKey, renderFunctionForField, renderFunctions, renderInsert, renderQuery, renderQueryGroupBy, renderQueryJoins, renderQueryOrderBy, renderQueryWhere, renderSequences, renderTable, renderTriggers, renderUnique, renderValue, setEventManager, setPostConnectionProperties, setQueryStatementProperties, shouldQuoteID`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### SQLServerDatabaseProvider

    public SQLServerDatabaseProvider(DisposableDataSource dataSource)

Method Detail

### setQueryResultSetProperties

    public void setQueryResultSetProperties(ResultSet res,
                                            Query query)
                                     throws SQLException

  Description copied from class: `DatabaseProvider`
  Allows the provider to set database-specific options on a `ResultSet` instance prior to its use by the library. This allows for features such as row offsetting even on databases that don't support it (such as Oracle, Derby, etc).

  Overrides:
    `setQueryResultSetProperties` in class `DatabaseProvider`
  Parameters:
    `res` - The `ResultSet` to modify.
    `query` - The query instance which was run to produce the result set.
  Throws:
    `SQLException`

### getTables

    public ResultSet getTables(Connection conn)
                        throws SQLException

  Description copied from class: `DatabaseProvider`

  Returns a result set of all of the tables (and associated meta) in the database. The fields of the result set must correspond with those specified in the `DatabaseMetaData#getTables(String, String, String, String[])` method. In fact, the default implementation merely calls this method passing `(null, null, "", null)`. For databases (such as PostgreSQL) where this is unsuitable, different parameters can be specified to the `getTables` method in the override, or an entirely new implementation written, as long as the result set corresponds in fields to the JDBC spec.

  Overrides:
    `getTables` in class `DatabaseProvider`
  Parameters:
    `conn` - The connection to use in retrieving the database tables.
  Returns:
    A result set of tables (and meta) corresponding in fields to the JDBC specification.
  Throws:
    `SQLException`
  See Also:
    `DatabaseMetaData.getTables(String, String, String, String[])`

### parseValue

    public Object parseValue(int type,
                             String value)

  Description copied from class: `DatabaseProvider`

  Parses the database-agnostic `String` value relevant to the specified SQL type in `int` form (as defined by `Types` and returns the Java value which corresponds. This method is completely database-agnostic, as are all of all of its delegate methods.

  WARNING: This method is being considered for removal to another class (perhaps `TypeManager`?) as it is not a database-specific function and thus confuses the purpose of this class. Do not rely upon it heavily. (better yet, don't rely on it at all from external code. It's not designed to be part of the public API)

  Overrides:
    `parseValue` in class `DatabaseProvider`
  Parameters:
    `type` - The JDBC integer type of the database field against which to parse the value.
    `value` - The database-agnostic String value to parse into a proper Java object with respect to the specified SQL type.
  Returns:
    A Java value which corresponds to the specified String.

### renderQuerySelect

    protected String renderQuerySelect(Query query,
                                       TableNameConverter converter,
                                       boolean count)

  Description copied from class: `DatabaseProvider`

  Renders the SELECT portion of a given `Query` instance in the manner required by the database-specific SQL implementation. Usually, this is as simple as `"SELECT id FROM table"` or `"SELECT DISTINCT * FROM table"`. However, some databases require the limit and offset parameters to be specified as part of the SELECT clause. For example, on HSQLDB, a Query for the "id" field limited to 10 rows would render SELECT like this: `SELECT TOP 10 id FROM table`.

  There is usually no need to call this method directly. Under normal operations it functions as a delegate for `DatabaseProvider.renderQuery(Query, TableNameConverter, boolean)`.

  Overrides:
    `renderQuerySelect` in class `DatabaseProvider`
  Parameters:
    `query` - The Query instance from which to determine the SELECT properties.
    `converter` - The name converter to allow conversion of the query entity interface into a proper table name.
    `count` - Whether or not the query should be rendered as a `SELECT COUNT(*)`.
  Returns:
    The database-specific SQL rendering of the SELECT portion of the query.

### renderQueryLimit

    protected String renderQueryLimit(Query query)

  Description copied from class: `DatabaseProvider`

  Renders the LIMIT portion of the query in the database-specific SQL dialect. There is wide variety in database implementations of this particular SQL clause. In fact, many database do not support it at all. If the database in question does not support LIMIT, this method should be overridden to return an empty String. For such databases, LIMIT should be implemented by overriding `DatabaseProvider.setQueryResultSetProperties(ResultSet, Query)` and `DatabaseProvider.setQueryStatementProperties(Statement, Query)`.

  An example return value: `" LIMIT 10,2"`

  There is usually no need to call this method directly. Under normal operations it functions as a delegate for `DatabaseProvider.renderQuery(Query, TableNameConverter, boolean)`.

  Overrides:
    `renderQueryLimit` in class `DatabaseProvider`
  Parameters:
    `query` - The Query instance from which to determine the LIMIT properties.
  Returns:
    The database-specific SQL rendering of the LIMIT portion of the query.

### renderAutoIncrement

    protected String renderAutoIncrement()

  Description copied from class: `DatabaseProvider`

  Generates the DDL fragment required to specify an INTEGER field as auto-incremented. For databases which do not support such flags (which is just about every database exception MySQL), `""` is an acceptable return value. This method should never return `null` as it would cause the field rendering method to throw a `NullPointerException`.

  Overrides:
    `renderAutoIncrement` in class `DatabaseProvider`

### renderOnUpdate

    protected String renderOnUpdate(DDLField field)

  Description copied from class: `DatabaseProvider`

  Renders the appropriate field suffix to allow for the `OnUpdate` functionality. For most databases (read: all but MySQL) this will return an empty String. This is because few databases provide an implicit ON UPDATE syntax for fields. As such, most databases will be compelled to return an empty String and implement the functionality using triggers.

  Overrides:
    `renderOnUpdate` in class `DatabaseProvider`
  Parameters:
    `field` - The field for which the ON UPDATE clause should be rendered.
  Returns:
    The database-specific ON UPDATE field clause.

### convertTypeToString

    protected String convertTypeToString(DatabaseType<?> type)

  Description copied from class: `DatabaseProvider`
  Converts the specified type into the database-specific DDL String value. By default, this delegates to the `DatabaseType#getDefaultName()` method. Subclass implementations should be sure to make a `super` call in order to ensure that both default naming and future special cases are handled appropriately.

  Overrides:
    `convertTypeToString` in class `DatabaseProvider`
  Parameters:
    `type` - The type instance to convert to a DDL string.
  Returns:
    The database-specific DDL representation of the type (e.g. "VARCHAR").
  See Also:
    `DatabaseType.getDefaultName()`

### considerPrecision

    protected boolean considerPrecision(DDLField field)

  Description copied from class: `DatabaseProvider`

  Determines whether or not the database allows explicit precisions for the field in question. This is to support databases such as Derby which do not support precisions for certain types. By default, this method returns `true`.

  More often than not, all that is required for this determination is the type. As such, the method signature may change in a future release.

  Overrides:
    `considerPrecision` in class `DatabaseProvider`
  Parameters:
    `field` - The field for which precision should/shouldn't be rendered.
  Returns:
    `true` if precision should be rendered, otherwise `false`.

### renderFunction

    protected String renderFunction(DatabaseFunction func)

  Description copied from class: `DatabaseProvider`

  Renders the specified `DatabaseFunction` in its database-specific form. For example, for MySQL the `CURRENT_DATE` enum value would be rendered as "`CURRENT_DATE`" (without the quotes). For functions which do not have a database equivalent, a default literal value of the appropriate type should be returned. For example, if MySQL did not define either a CURRENT_DATE or a CURRENT_TIMESTAMP function, the appropriate return value for both functions would be `'0000-00-00 00:00:00'` (including the quotes). This is to prevent migrations from failing even in cases where non-standard functions are used.

  As of 1.0, no unconventional functions are allowed by the `DatabaseFunction` enum, thus no database should have any problems with any allowed functions.

  Overrides:
    `renderFunction` in class `DatabaseProvider`
  Parameters:
    `func` - The abstract function to be rendered.
  Returns:
    The database-specific DDL representation of the function in question.

### renderTriggerForField

    protected String renderTriggerForField(DDLTable table,
                                           DDLField field)

  Description copied from class: `DatabaseProvider`
  Renders the trigger which corresponds to the specified field, or `null` if none. This is to allow for databases which require the use of triggers to provide functionality such as ON UPDATE. The default implementation returns `null`.

  Overrides:
    `renderTriggerForField` in class `DatabaseProvider`
  Parameters:
    `table` - The table containing the field for which a trigger may need to be rendered.
    `field` - The field for which the trigger should be rendered, if any.
  Returns:
    A database-specific DDL statement creating a trigger for the field in question, or `null`.
  See Also:
    `DatabaseProvider.getTriggerNameForField(DDLTable, DDLField)`

### renderAlterTableChangeColumnStatement

    protected String renderAlterTableChangeColumnStatement(DDLTable table,
                                                           DDLField oldField,
                                                           DDLField field)

  Description copied from class: `DatabaseProvider`
  Generates the database-specific DDL statement only for altering a table and changing a column. This method must only generate a single statement as it does not need to concern itself with functions or triggers associated with the column. This method is only to be called as a delegate for the `DatabaseProvider.renderAlterTableChangeColumn(DDLTable, DDLField, DDLField)` method, for which it is a primary delegate. The default implementation of this method functions according to the MySQL specification.

  Overrides:
    `renderAlterTableChangeColumnStatement` in class `DatabaseProvider`
  Parameters:
    `table` - The table containing the column to change.
    `oldField` - The old column definition.
    `field` - The new column definition (defining the resultant DDL).
  Returns:
    A single DDL statement which is to be executed.
  See Also:
    `DatabaseProvider.renderField(DDLField)`

### renderAlterTableAddColumn

    protected String[] renderAlterTableAddColumn(DDLTable table,
                                                 DDLField field)

  Description copied from class: `DatabaseProvider`
  Generates the database-specific DDL statements required to add a column to an existing table. Included in the return value should be the statements required to add all necessary functions and triggers to ensure that the column acts appropriately. For example, if the field is tagged with an `@OnUpdate` annotation, chances are there will be a trigger and possibly a function along with the ALTER statement. These "extra" functions are properly ordered and will only be appended if their values are not `null`. Because of this, very few database providers will need to override this method.

  Overrides:
    `renderAlterTableAddColumn` in class `DatabaseProvider`
  Parameters:
    `table` - The table which should receive the new column.
    `field` - The column to add to the specified table.
  Returns:
    An array of DDL statements to execute.
  See Also:
    `DatabaseProvider.renderFunctionForField(DDLTable, DDLField)`, `DatabaseProvider.renderTriggerForField(DDLTable, DDLField)`

### renderAlterTableDropKey

    protected String renderAlterTableDropKey(DDLForeignKey key)

  Description copied from class: `DatabaseProvider`
  Generates the database-specific DDL statement required to remove a foreign key from a table. For databases which do not support such a statement, a warning should be printed to stderr and a `null` value returned. This method assumes that the `DatabaseProvider.renderForeignKey(DDLForeignKey)` method properly names the foreign key according to the `DDLForeignKey.getFKName()` method.

  Overrides:
    `renderAlterTableDropKey` in class `DatabaseProvider`
  Parameters:
    `key` - The foreign key to be removed. As this instance contains all necessary data (such as domestic table, field, etc), no additional parameters are required.
  Returns:
    A DDL statement to be executed, or `null`.

### insertReturningKey

    public <T> T insertReturningKey(EntityManager manager,
                                    Connection conn,
                                    Class<T> pkType,
                                    String pkField,
                                    boolean pkIdentity,
                                    String table,
                                    DBParam... params)
                         throws SQLException

  Description copied from class: `DatabaseProvider`

  Generates an INSERT statement to be used to create a new row in the database, returning the primary key value. This method also invokes the delegate method, `DatabaseProvider.executeInsertReturningKey(EntityManager, Connection, Class, String, String, DBParam...)` passing the appropriate parameters and query. This method is required because some databases do not support the JDBC parameter `RETURN_GENERATED_KEYS` (such as HSQLDB and PostgreSQL). Also, some databases (such as MS SQL Server) require odd tricks to support explicit value passing to auto-generated fields. This method should take care of any extra queries or odd SQL generation required to implement both auto-generated primary key returning, as well as explicit primary key value definition.

  Overriding implementations of this method should be sure to use the `Connection` instance passed to the method, not a new instance generated using the `DatabaseProvider.getConnection()` method. This is because this method is in fact a delegate invoked by `EntityManager` as part of the entity creation process and may be part of a transaction, a bulk creation or some more complicated operation. Both optimization and usage patterns on the API dictate that the specified connection instance be used. Implementations may assume that the given connection instance is never `null`.

  The default implementation of this method should be sufficient for any fully compliant ANSI SQL database with a properly implemented JDBC driver. Note that this method should not not actually execute the SQL it generates, but pass it on to the `DatabaseProvider.executeInsertReturningKey(EntityManager, Connection, Class, String, String, DBParam...)` method, allowing for functional delegation and better extensibility. However, this method may execute any additional statements required to prepare for the INSERTion (as in the case of MS SQL Server which requires some config parameters to be set on the database itself prior to INSERT).

  Overrides:
    `insertReturningKey` in class `DatabaseProvider`
  Parameters:
    `manager` - The `EntityManager` which was used to dispatch the INSERT in question.
    `conn` - The connection to be used in the eventual execution of the generated SQL statement.
    `pkType` - The Java type of the primary key value. Can be used to perform a linear search for a specified primary key value in the `params` list. The return value of the method must be of the same type.
    `pkField` - The database field which is the primary key for the table in question. Can be used to perform a linear search for a specified primary key value in the `params` list.
    `pkIdentity` - Flag indicating whether or not the primary key field is auto-incremented by the database (IDENTITY field).
    `table` - The name of the table into which the row is to be INSERTed.
    `params` - A varargs array of parameters to be passed to the INSERT statement. This may include a specified value for the primary key.
  Throws:
    `SQLException` - If the INSERT fails in the delegate method, or if any additional statements fail with an exception.
  See Also:
    `DatabaseProvider.executeInsertReturningKey(EntityManager, Connection, Class, String, String, DBParam...)`

### getReservedWords

    protected Set<String> getReservedWords()

  Description copied from class: `DatabaseProvider`
  Retrieves the set of all reserved words for the underlying database. The set returns should be speculative, meaning that it should include any possible reserved words, not just those for a particular version. As an implementation guideline, the `Set` instance returned from this method should guarentee O(1) lookup times, otherwise ORM performance will suffer greatly.

  Specified by:
    `getReservedWords` in class `DatabaseProvider`
  Returns:
    A set of upper case reserved words specific to the database.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2007-2011. All Rights Reserved.